<template>
  <button
    :disabled="disabled"
    class="group flex items-center justify-center gap-x-1 disabled:cursor-not-allowed font-semibold"
    :class="buttonClass"
  >
    <span v-if="leftIcon" :class="leftIcon"></span>
    <slot></slot>
    <span v-if="rightIcon" :class="rightIcon"></span>
  </button>
</template>

<script setup lang="ts">
import { TuButtonVariant } from './interfaces'
import { computed } from 'vue'

interface Props {
  leftIcon?: string
  rightIcon?: string
  disabled?: boolean
  variant?: TuButtonVariant
}

const props = withDefaults(defineProps<Props>(), {
  variant: 'primary',
})

const hasIcon = computed(() => props.leftIcon || props.rightIcon)

const classByVariant: Record<TuButtonVariant, string> = {
  primary: `
      h-12 min-h-12 px-6 py-3 rounded-10 text-sm text-white
      bg-[#1D75F9] hover:bg-[#2A40C7] active:bg-[#2A40C7] disabled:bg-[#CDCFD1]
    `,
  secondary: `
      h-12 min-h-12 px-6 py-3 rounded-10 text-sm text-[#1D8EF2]
      bg-[#E3F3FF] hover:bg-[#BBDFFF] active:bg-[#BBDFFF] disabled:bg-[#EBEBEB] disabled:bg-opacity-50 disabled:text-[#CDCFD1]
    `,
  'secondary-icon': `
      h-12 min-h-12 w-12 min-w-12 p-3 rounded-10 text-sm border text-[#1D8EF2] border-[#1D8EF2]
      active:bg-[#2A40C7] active:text-white hover:bg-[#2A40C7] hover:text-white
      disabled:bg-transparent disabled:border-[#CDCFD1] disabled:text-[#CDCFD1]
    `,
  tertiary: `
      h-6 min-h-6 rounded-2xl text-sm text-[#1D75F9]
      ${hasIcon.value ? 'px-1' : 'px-2'} text-sm
      hover:text-[#0261B6] active:text-[#0261B6] disabled:text-[#CDCFD1]
    `,
  'tertiary-grey': `
      h-6 min-h-6 rounded-2xl text-sm text-[#8D939A]
      ${hasIcon.value ? 'px-1' : 'px-2'}
      hover:text-[#646870] active:text-[#646870] disabled:text-[#CDCFD1]
    `,
}

const buttonClass = computed((): string => {
  return classByVariant[props.variant]
})
</script>

<style scoped></style>
